SystemOrganization addCategory: #'Deltawerken-Actions'!

Object subclass: #DEWorkflowAction
	instanceVariableNames: 'label url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Actions'!

DEWorkflowAction subclass: #DEGenericWorkflowAction
	instanceVariableNames: 'preCondition action isAllowedFor view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Actions'!

!DEGenericWorkflowAction methodsFor: 'processing' stamp: 'DiegoLont 3/12/2012 15:15'!
actOn: anObject context: aContext
	self action ifNotNil: [ ^self action value: anObject value: aContext ]! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
action
	^ action! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
action: anObject
	action := anObject! !

!DEGenericWorkflowAction methodsFor: 'processing' stamp: 'DiegoLont 3/12/2012 15:15'!
canDo: aDomainObject
	self preCondition ifNotNil: [ ^self preCondition value: aDomainObject ].
	^true! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
contextFor: html
	self view ifNotNil: [ ^view ].
	^super contextFor: html! !

!DEGenericWorkflowAction methodsFor: 'processing' stamp: 'DiegoLont 3/12/2012 15:15'!
isAllowed: aDomainObject for: aUser
	self isAllowedFor ifNotNil: [ ^self isAllowedFor value: aDomainObject value: aUser ].
	^true! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
isAllowedFor
	^isAllowedFor! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
isAllowedFor: aBlock
	isAllowedFor := aBlock! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
preCondition
	^ preCondition! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
preCondition: aPreCondition
	preCondition := aPreCondition! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
view
	^ view! !

!DEGenericWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
view: anObject
	view := anObject! !

!DEWorkflowAction methodsFor: 'processing' stamp: 'DiegoLont 3/12/2012 15:15'!
actOn: anObject context: aContext
	self subclassResponsibility! !

!DEWorkflowAction methodsFor: 'processing' stamp: 'DiegoLont 3/12/2012 15:15'!
canDo: aDomainObject
	^false! !

!DEWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
contextFor: html
	^html! !

!DEWorkflowAction methodsFor: 'processing' stamp: 'DiegoLont 3/12/2012 15:15'!
isAllowed: aDomainObject for: aUser
	^true! !

!DEWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
label
	^ label! !

!DEWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
label: anObject
	label := anObject! !

!DEWorkflowAction methodsFor: 'rendering' stamp: 'DiegoLont 3/12/2012 15:27'!
render: aDomainObject context: aContext on: canvas
	url ifNil: [
		canvas anchor
			callback: [ self actOn: aDomainObject context: aContext ];
			with: label]
	ifNotNil: [
		canvas anchor
				callback: [ self actOn: aDomainObject context: aContext ];
				with: [canvas image
					title: label;
					url: url]]! !

!DEWorkflowAction methodsFor: 'rendering' stamp: 'DiegoLont 4/3/2012 16:03'!
render: aDomainObject on: canvas
	self url ifNil: [
		canvas anchor
			callback: [ self actOn: aDomainObject context: (self contextFor: canvas) ];
			with: label]
	ifNotNil: [
		canvas anchor
				callback: [ self actOn: aDomainObject context: (self contextFor: canvas) ];
				with: [ canvas image
					title: label;
					url: self url ] ]! !

!DEWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
url
	^ url! !

!DEWorkflowAction methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 15:15'!
url: anObject
	url := anObject! !
